-- ralisation des spcifications de P_Moucheron.Eve
-- fichier tpalgo/p_moucheron-eve.adb 
-- D.F. janvier 2004
-- version 1.0 (anne.ordre)

with Ada.Text_Io;
use Ada.Text_Io;
with Ada.Characters.Latin_1;
use Ada.Characters.Latin_1;
with Glib;
use Glib;
with Gtk.Text;
use Gtk.Text;
with Gdk.Font;
use Gdk.Font;
with Gdk.Color;
use Gdk.Color;
with Window1_Pkg;
use Window1_Pkg;
with Create_File_Selection;
with Gtk.Frame;
use Gtk.Frame;
with Glib.Convert;
use Glib.Convert;
with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;

package body P_Moucheron.Eve is
   Message : Unbounded_String;  

   procedure Ecrire_Compteur is 
      -- dite la valeur du compteur
      Color_Back : Gdk_Color;  
      Color_Fore : Gdk_Color;  
      Mes        : String (1 .. 5);  
      Long       : Natural;  
   begin
      Mes := (others => Space);
      Long := T_Compteur'Image(Compteur)'Length;
      Mes(1..Long) := T_Compteur'Image(Compteur);
      Set_Rgb (Color_Back,0,0,16#FFFF#);
      Set_Rgb (Color_Fore,16#FFFF#,16#FFFF#,0);
      Insert (Window1.Text1,Null_Font,Color_Fore,Color_Back,
         Mes & Lf,Gint(Long)+1);
   end Ecrire_Compteur;

   procedure Montrer_Ruban (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      Buffer     : String (1 .. 1024);  
      Long       : Natural;  
      Color_Back : Gdk_Color;  
      Color_Fore : Gdk_Color;  
   begin
      A_La_Ligne;
      loop
         exit when End_Of_File(Ruban);
         Get_Line(Ruban,Buffer,Long);
         
         -- gestion des lignes accentues
         Message := To_Unbounded_String(Filename_To_Utf8 (Buffer(1..Long))) ;
         Long := Length (Message);
         Buffer (1..Long) := To_String (Message);

         Set_Rgb (Color_Back,0,0,16#FFFF#);
         Set_Rgb (Color_Fore,16#FFFF#,16#FFFF#,0);
         Insert (Window1.Text1,Null_Font,Color_Fore,Color_Back,
            Buffer(1..Long) & Lf,Gint(Long)+1);
      end loop;
      A_La_Ligne;
   end Montrer_Ruban;

   procedure Autre_Ruban (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      Fich_Sel : aliased Gtk.Frame.Gtk_Frame_Record;  
   begin
      Create_File_Selection.Run(Fich_Sel'access);
   end Autre_Ruban;

   procedure Reset (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

   begin
      Reset(Ruban);
   end Reset;

   procedure Ecrire (
         Mes : in     String ) is 
      Color_Back : Gdk_Color;  
      Color_Fore : Gdk_Color;  
      Mes2       : String (1 .. 1024);  
      Long       : Natural;  
   begin
      Mes2 := (others => Space);
      Long := Mes'Length;
      Mes2(1..Long) := Mes;
      
      -- gestion des accents
      Message := To_Unbounded_String(Filename_To_Utf8 (Mes2(1..Long))) ;
      Long := Length (Message);
      Mes2 (1..Long) := To_String (Message);

      Set_Rgb (Color_Back,0,0,16#FFFF#);
      Set_Rgb (Color_Fore,16#FFFF#,16#FFFF#,0);
      Insert (Window1.Text1,Null_Font,Color_Fore,Color_Back,
         Mes2 ,Gint(Long));
   end Ecrire;

   procedure A_La_Ligne is 
   begin
      Insert (Window1.Text1,Null_Font,Null_Color,Null_Color,
         ' ' & Lf,Gint(2));
   end A_La_Ligne;

end P_Moucheron.Eve;