-- ralisation des spcifications de P_Moucheron.Imp 
-- D.F. et T.A. fvrier 2001
-- version 1.1 (anne.ordre)
-- fichier tpalgo/p_moucheron-imp.adb

with Ada.Text_Io;
use Ada.Text_Io;
with Ada.Exceptions;
use Ada.Exceptions;
with Ada.Command_Line;
use Ada.Command_Line ;
with P_E_Sortie;
with Ada.Strings.Fixed;
with Ada.Strings.Maps.Constants;
use Ada.Strings.Fixed;
use Ada.Strings.Maps.Constants;
use P_E_Sortie;

package body P_Moucheron.Imp is
   Fichier : File_Type;  
   -- fichier qui contient les noms des rubans
   -- Fichier est ouvert dans le bloc d'initialisation
   Num_Tp : Character; -- initialis dans le bloc   
   -- 
   -- fonctionnalits pour programmation dterministe :
   --
   procedure Ecrire_Compteur is 
   begin
      Put (T_Compteur'Image(Compteur));
   end Ecrire_Compteur;


   procedure Ouvrir is 
      -- 
      -- utilis par Autre_Ruban d'une part et au dbut
      -- par le bloc d'initialisation d'autre part
      -- qui doit initialiser un ruban au dmarrage
      --
      Nom  : String (1 .. 80);  
      Long : Natural;  
   begin -- Ouvrir

      Y_A_Plus_De_Ruban := False;
      Get_Line (Fichier,Nom,Long);
      New_line;
      Put_Line ("Nom du ruban : " & Nom(1..Long));
      New_Line;
      Open (
         File => Ruban,           
         Name => Nom (1 .. Long), 
         Mode => In_File);
   exception
      when Name_Error =>
         Raise_Exception(Name_Error'Identity,
            "pas de ruban  ce nom : arrt du programme!");
      when others =>
         Y_A_Plus_De_Ruban := True;
   end Ouvrir;

   -- ralisations des commandes (sans paramtre) pr-programmes
   -- annonces dans les spcifications du paquetage

   procedure Reset is 
   begin
      Reset (Ruban);
   end Reset;

   procedure Autre_Ruban is 
   begin
      Close (Ruban);
      Ouvrir;
   end Autre_Ruban;

   procedure Montrer_Ruban is 
      Car : Character;  
   begin
      New_Line;
      loop  -- bon modle de parcours de fichier texte
         exit when End_Of_File(Ruban);
         if End_Of_Page(Ruban)
               then
            Skip_Page(Ruban);
         elsif End_Of_Line (Ruban)
               then
            Skip_Line(Ruban); -- saut ligne dans le Ruban
            New_Line;         -- criture d'un saut ligne  l'cran
         else
            Get (Ruban, Car); -- lecture du caractre courant
            Ecrire (Car);
         end if;
      end loop;
      New_Line;
   end Montrer_Ruban;

begin
   Dos := (Argument_Count = 1) and then
      (Translate(Argument(1), Upper_Case_Map) = "DOS");
   -- utile pour tester sur PC avec NT
   Num_Tp := Command_Name(Index(Command_Name,"ts_moucheron") + 12);
   -- Num_Tp va de '0'  '9'
   Open (Fichier,In_File,"testtp" & Num_Tp & ".txt");
   -- fichier contenant les noms des rubans
   Ouvrir;
end P_Moucheron.Imp;