-- ralisation des spcifications de P_Moucheron
-- fichier tpalgo/p_moucheron.adb 
-- D.F. et T.A. fvrier 2001
-- version 1.1 (anne.ordre)

with Ada.Exceptions;
package body P_Moucheron is

   use Ada.Text_Io;
   use Ada.Exceptions;
   --
   -- fonctionnalits communes aux deux styles de programmation :
   -- vnementielle et dterministe
   --

   function Fin_Ruban return Boolean is 
   begin
      return End_Of_File (Ruban); -- renvoie si Ruban est fini
   end Fin_Ruban;


   procedure Lire is 
      -- travaille sur le ruban (ou fichier) Ruban "ouvert"
      -- initialise Carcou  chaque instruction Lire

   begin -- Lire
      if End_Of_File(Ruban) -- tentative de dpassement
            then
         raise End_Error;
      end if;
      if End_Of_Line(Ruban)
            then
         Skip_Line(Ruban);
         Carcou := ' ';
         -- une fin de ligne est ainsi compte comme un espace
      else
         Get (Ruban, Carcou);
      end if;
   exception
      when End_Error =>
         Raise_Exception (End_Error'Identity,
            "lecture aprs fin de ruban!");
      when Marqueur : others =>
         Raise_Exception (Exception_Identity(Marqueur),
            "problme avec when others dans LIRE");
   end Lire;

end P_Moucheron;