-- fichier p_moucheron-eve-moucheron6_7.adb 
-- pour TP 6_7 (2 heures seulement pour faire aussi TP 8)
--  faire  partir de p_moucheron-eve-moucheron6_7.squ
-- D. Feneuille  janvier 2004

with Ada.Characters.Latin_1;

package body P_Moucheron.Eve.Moucheron6_7 is

   -- crire ici le dtail des commandes de la machine 
   -- soit les trois versions de NB_PREMIER_MOT (V1, V2 et V3)
   -- travaillez globalement avec la variable COMPTEUR ( mettre  UN!!!!!!) 

   -- declaration types et constante :

   Max_Long : constant           := 20;  
   Drapeau  :          Character := Ada.Characters.Latin_1.Nul;  
   type T_Mots is array (Positive range <>) of Character; 

   subtype T_Long is Positive range 1 .. Max_Long;
   subtype T_Les_Mots is T_Mots (T_Long);

   -- dclaration de variables (elles seront globales  la plupart
   -- des modules c'est un dfaut mais ce n'est pas important pour ici)

   Premot  : T_Les_Mots;  
   Motsuiv : T_Les_Mots;  

   Long_Premot  : T_Long;  
   Long_Motsuiv : T_Long;  

   -- dclaration de modules "primitives"
   procedure Sauter_Les_Blancs; 
   procedure Premier_Mot; 
   procedure Mot_Suivant; 
   procedure Comparer; 
   procedure Passer_Le_Mot; 
   procedure Comparer_Direct; 
   procedure Pre_Mot_Drap;  --  faire en TP
   procedure Compar_Dir_Drap; --  faire en TP

   -- dclaration et dfinition des procdures principales

   procedure Nb_Premier_Mot_V1 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      --  faire en TP
   begin
      if Fin_Ruban
            then
         return;
      end if;
      -- il doit toujours y avoir un premier mot
      Compteur := 1;
      Lire;
      Sauter_Les_Blancs;
      Premier_Mot;
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Mot_Suivant;
         Comparer;
      end loop;
      Ecrire ("Nombre de premier mot version 1  = ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Nb_Premier_Mot_V1;

   procedure Nb_Premier_Mot_V2 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

   begin
      if Fin_Ruban
            then
         return;
      end if;
      -- il doit toujours y avoir un premier mot
      Compteur := 1;
      Lire;
      Sauter_Les_Blancs;
      Premier_Mot;
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Comparer_Direct;
         Passer_Le_Mot;
      end loop;
      Ecrire ("Nombre de premier mot version 2  = ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Nb_Premier_Mot_V2;

   procedure Nb_Premier_Mot_V3 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      -- version identique  la 2 sauf les primitives
   begin
      if Fin_Ruban
            then
         return;
      end if;
      -- il doit toujours y avoir un premier mot

      Compteur := 1;
      Lire;
      Sauter_Les_Blancs;
      Pre_Mot_Drap;
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Compar_Dir_Drap;
         Passer_Le_Mot;
      end loop;
      Ecrire ("Nombre de premier mot version 3  = ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Nb_Premier_Mot_V3;

   -- dfinition des "primitives"

   procedure Sauter_Les_Blancs is 
   begin
      loop
         exit when (Carcou /= ' ') or Fin_Ruban;
         Lire;
      end loop;
   end Sauter_Les_Blancs;

   procedure Premier_Mot is 
      Ind : T_Long := 1;  
   begin -- PREMIER_MOT
      -- le caractre du premier mot existe dans CARCOU
      Premot (Ind) := Carcou;
      loop
         exit when Fin_Ruban;
         -- un nouveau caractre est dans CARCOU
         Lire;
         exit when Carcou = ' ';
         Ind := Ind + 1;
         Premot (Ind) := Carcou;
      end loop;
      Long_Premot := Ind;   -- ne pas oublier
   end Premier_Mot;

   procedure Mot_Suivant is 
      Ind : T_Long := 1;  
   begin -- MOT_SUIVANT
      Motsuiv (Ind) := Carcou;
      loop
         exit when Fin_Ruban;
         Lire;
         exit when Carcou = ' ';
         Ind := Ind + 1;
         Motsuiv (Ind) := Carcou;
      end loop;
      Long_Motsuiv := Ind;
   end Mot_Suivant;

   procedure Comparer is 
      Ind : T_Long;  
   begin
      if Long_Premot = Long_Motsuiv
            then
         Ind := 1;
         loop
            exit when (Premot (Ind) /= Motsuiv (Ind)) or (Ind = Long_Premot);
            Ind := Ind  +  1;
         end loop;
         if (Premot (Ind) = Motsuiv (Ind))
               then
            Compteur := Compteur + 1;
         end if;
      end if;
   end Comparer;

   procedure Passer_Le_Mot is 
   begin
      loop
         exit when (Fin_Ruban) or (Carcou = ' ');
         Lire;
      end loop;
   end Passer_Le_Mot;

   procedure Comparer_Direct is 
      Ind : T_Long := 1;  
   begin
      loop
         exit when (Carcou /= Premot (Ind))
            or (Ind = Long_Premot)
            or (Fin_Ruban);
         Ind := Ind  +  1;
         Lire;
      end loop; -- faire l'tude des conditions de sortie!!
      -- voir TD 7 (important!!)
      if (Carcou = Premot (Ind)) and (Ind = Long_Premot)
            then
         if Fin_Ruban
               then
            Compteur := Compteur  +  1;
         else
            Lire;
            if Carcou = ' '
                  then
               Compteur := Compteur  +  1;
            end if;
         end if;
      end if;
   end Comparer_Direct;

   procedure Pre_Mot_Drap is     --  faire en TP
      Ind : T_Long := 1;  
   begin
      -- le caractre du premier mot existe dans CARCOU
      Premot (Ind) := Carcou;
      loop
         exit when Fin_Ruban;
         -- un nouveau caractre est dans CARCOU
         Lire;
         exit when Carcou = ' ';
         Ind := Ind + 1;
         Premot (Ind) := Carcou;
      end loop;
      Premot (Ind + 1) := Drapeau;
   end Pre_Mot_Drap;

   procedure Compar_Dir_Drap is    --  faire en TP
      Ind : T_Long := 1;  
   begin
      loop
         exit when (Carcou /= Premot (Ind))
            or (Fin_Ruban);
         Ind := Ind + 1;
         Lire;
      end loop;
      if ((Drapeau = Premot (Ind)) and (Carcou = ' '))
            or ((Fin_Ruban) and (Drapeau = Premot (Ind + 1)))
            then
         Compteur := Compteur + 1;
      end if;
   end Compar_Dir_Drap;

end P_Moucheron.Eve.Moucheron6_7;